Adding update method, usage and -f option

This commit is contained in:
Alex Epstein 2017-08-03 01:57:29 -04:00
parent bbb1f8a728
commit 7b8200bb86
1 changed files with 81 additions and 9 deletions

View File

@ -6,7 +6,7 @@ configuredClient=""
currentVersion="1.17.3"
single="false"
down="false"
singlef="false"
## This function determines which http get tool the system has installed and returns an error if there isnt one
getConfiguredDownloadClient()
{
@ -73,6 +73,46 @@ httpDownload()
esac
}
update()
{
# Author: Alexander Epstein https://github.com/alexanderepstein
# Update utility version 1.2.0
# To test the tool enter in the defualt values that are in the examples for each variable
repositoryName="Bash-Snippets" #Name of repostiory to be updated ex. Sandman-Lite
githubUserName="alexanderepstein" #username that hosts the repostiory ex. alexanderepstein
nameOfInstallFile="install.sh" # change this if the installer file has a different name be sure to include file extension if there is one
latestVersion=$(httpGet https://api.github.com/repos/$githubUserName/$repositoryName/tags | grep -Eo '"name":.*?[^\\]",'| head -1 | grep -Eo "[0-9.]+" ) #always grabs the tag without the v option
if [[ $currentVersion == "" || $repositoryName == "" || $githubUserName == "" || $nameOfInstallFile == "" ]]; then
echo "Error: update utility has not been configured correctly." >&2
exit 1
elif [[ $latestVersion == "" ]]; then
echo "Error: no active internet connection" >&2
exit 1
else
if [[ "$latestVersion" != "$currentVersion" ]]; then
echo "Version $latestVersion available"
echo -n "Do you wish to update $repositoryName [Y/n]: "
read -r answer
if [[ "$answer" == [Yy] ]]; then
cd ~ || { echo 'Update Failed'; exit 1; }
if [[ -d ~/$repositoryName ]]; then rm -r -f $repositoryName || { echo "Permissions Error: try running the update as sudo"; exit 1; } ; fi
git clone "https://github.com/$githubUserName/$repositoryName" || { echo "Couldn't download latest version"; exit 1; }
cd $repositoryName || { echo 'Update Failed'; exit 1; }
git checkout "v$latestVersion" 2> /dev/null || git checkout "$latestVersion" 2> /dev/null || echo "Couldn't git checkout to stable release, updating to latest commit."
chmod a+x install.sh #this might be necessary in your case but wasnt in mine.
./$nameOfInstallFile "update" || exit 1
cd ..
rm -r -f $repositoryName || { echo "Permissions Error: update succesfull but cannot delete temp files located at ~/$repositoryName delete this directory with sudo"; exit 1; }
else
exit 1
fi
else
echo "$repositoryName is already the latest version"
fi
fi
}
checkInternet()
{
httpGet github.com > /dev/null 2>&1 || { echo "Error: no active internet connection" >&2; return 1; } # query github with a get request
@ -118,7 +158,27 @@ singleUpload()
httpSingleUpload "$tempFilePath" "$tempFileName"
}
while getopts "s:d:uvh" opt; do
usage()
{
cat <<EOF
Transfer
Description: Quickly transfer files from the command line.
Usage: transfer [flags] or transfer [flag] [args]
-s Upload a single file, takes in file path as argument
-d Download a single file
First arg: Output file directory
Second arg: File url id
Third arg: File name
-u Update Bash-Snippet Tools
-h Show the help
-v Get the tool version
Examples:
transfer -s ~/fileToTransfer.txt
transfer -d ~/outputDirectory fileID fileName
EOF
}
while getopts "s:d:f:uvh" opt; do
case "$opt" in
\?) echo "Invalid option: -$OPTARG" >&2
exit 1
@ -129,17 +189,26 @@ while getopts "s:d:uvh" opt; do
v) echo "Version $currentVersion"
exit 0
;;
u) update
u)
getConfiguredClient || exit 1
checkInternet || exit 1
update || exit 1
exit 0
;;
d) down="true"
d)
down="true"
if [ $# -lt 4 ];then { echo "Error: not enough arguments for downloading a file, see the usage"; return 1;};fi
inputFilePath=$(echo "$*" | sed s/-d//g | cut -d " " -f 2)
inputID=$(echo "$*" | sed s/-d//g | cut -d " " -f 3)
inputFileName=$(echo "$*" | sed s/-d//g | cut -d " " -f 4)
;;
s) single="true"
inputFilePath=$(echo "$@" | sed s/-s//g)
s)
single="true"
inputFilePath=$OPTARG
;;
f)
singlef="true"
inputFilePath=$OPTARG
;;
:) echo "Option -$OPTARG requires an argument." >&2
exit 1
@ -147,7 +216,8 @@ while getopts "s:d:uvh" opt; do
esac
done
if $down && $single;then { echo "Error: upload and download are mutually exclusive";exit 1;};fi
if $down && ($single || $singlef);then { echo "Error: upload and download are mutually exclusive";exit 1;};fi
if $single && $singlef;then { echo "Error: only use -f or -d not both";exit 1;};fi
if [[ $# == "0" ]]; then
usage
@ -156,9 +226,11 @@ elif [[ $1 == "help" ]]; then
usage
exit 0
elif [[ $1 == "update" ]]; then
update
getConfiguredClient || exit 1
checkInternet || exit 1
update || exit 1
exit 0
elif $single ;then
elif $single || $singlef ;then
getConfiguredClient || exit 1
checkInternet || exit 1
getconfiguredUploadClient || exit 1